#include <amxmodx>
#include <cstrike>
#include <fun>

new g_PurchaseTime, Float:g_iTime;
new flash_pcs, flash_price, hegren_pcs, hegren_price, sgren_pcs, sgren_price, add_price;
new flash_add_price, hegren_add_price, sgren_add_price;

public plugin_init()
{
	register_plugin("Grenade Limit", "0.1.0", "Albertio");

	register_event("HLTV", "Event_RoundStart", "a", "1=0", "2=0");

	register_dictionary("grenade_limit.txt");

	bind_pcvar_num(create_cvar("gl_flash_pcs", "4", FCVAR_NONE, fmt("%L", LANG_SERVER, "GL_FLASH_PCS_CVAR"), true, 1.0), flash_pcs);
	bind_pcvar_num(create_cvar("gl_flash_price", "200", FCVAR_NONE, fmt("%L", LANG_SERVER, "GL_FLASH_PRICE_CVAR"), true, 0.0), flash_price);
	bind_pcvar_num(create_cvar("gl_hegren_pcs", "2", FCVAR_NONE, fmt("%L", LANG_SERVER, "GL_HEGREN_PCS_CVAR"), true, 1.0), hegren_pcs);
	bind_pcvar_num(create_cvar("gl_hegren_price", "300", FCVAR_NONE, fmt("%L", LANG_SERVER, "GL_HEGREN_PRICE_CVAR"), true, 0.0), hegren_price);
	bind_pcvar_num(create_cvar("gl_sgren_pcs", "2", FCVAR_NONE, fmt("%L", LANG_SERVER, "GL_SGREN_PCS_CVAR"), true, 1.0), sgren_pcs);
	bind_pcvar_num(create_cvar("gl_sgren_price", "300", FCVAR_NONE, fmt("%L", LANG_SERVER, "GL_SGREN_PRICE_CVAR"), true, 0.0), sgren_price);
	bind_pcvar_num(create_cvar("gl_add_price", "100", FCVAR_NONE, fmt("%L", LANG_SERVER, "GL_ADD_PRICE_CVAR"), true, 0.0), add_price);

	AutoExecConfig(true, "grenade_limit");
}

public Event_RoundStart()
{
	flash_add_price = flash_price;
	hegren_add_price = hegren_pcs;
	sgren_add_price = sgren_price;
	g_iTime = 60.0 * get_cvar_float("mp_buytime");
	g_PurchaseTime = get_cvar_num("mp_freezetime") + floatround(g_iTime, floatround_round);
	remove_task(3);
	set_task(1.0, "PurchaseTime", 3, _, _, "a", g_PurchaseTime);
}

public PurchaseTime()
{
	g_PurchaseTime--;
}

public client_command(id)
{
	if(is_user_alive(id))
	{
		new szCommand[13];
		if(read_argv(0, szCommand, charsmax(szCommand)) < 12)
		{
			return CheckBuyCmd(id, szCommand);
		}
	}
	return PLUGIN_CONTINUE;
}

public CS_InternalCommand(id, const szCommand[])
{
	if(is_user_alive(id))
	{
		new szCmd[13];
		if(copy(szCmd, charsmax(szCmd), szCommand) < 12)
		{
			return CheckBuyCmd(id, szCmd);
		}
	}
	return PLUGIN_CONTINUE;
}

public CheckBuyCmd(id, szCmd[])
{
	new iItem = GetAliasId(szCmd);
	if(iItem)
	{
		return CanBuyItem(id, iItem);
	}
	return PLUGIN_CONTINUE;
}

public CanBuyItem(id, iItem)
{
	if(g_PurchaseTime > 0)
	{
		if(iItem == CSW_FLASHBANG && !user_has_weapon(id, CSW_FLASHBANG))
		{
			if(cs_get_user_money(id) >= flash_price)
			{
				give_item(id, "weapon_flashbang");
				cs_set_user_money(id, cs_get_user_money(id) - flash_price);
			}
			else
			{
				client_print_color(id, print_team_default, "%L", id, "GL_FLASH_NOTMONEY");
			}
			return PLUGIN_HANDLED;
		}
		else if(iItem == CSW_FLASHBANG && user_has_weapon(id, CSW_FLASHBANG))
		{
			if(cs_get_user_bpammo(id, CSW_FLASHBANG) < flash_pcs)
			{
				if(cs_get_user_money(id) >= flash_add_price)
				{
					flash_add_price += add_price;
					cs_set_user_bpammo(id, CSW_FLASHBANG, cs_get_user_bpammo(id, CSW_FLASHBANG) + 1);
					cs_set_user_money(id, cs_get_user_money(id) - flash_add_price);
				}
				else
				{
					client_print_color(id, print_team_default, "%L", id, "GL_FLASH_NOTMONEY");
				}
			}
			else
			{
				client_print_color(id, print_team_default, "%L", id, "GL_FLASH_LIMIT");
			}
			return PLUGIN_HANDLED;
		}
		if(iItem == CSW_HEGRENADE && !user_has_weapon(id, CSW_HEGRENADE))
		{
			if(cs_get_user_money(id) >= hegren_price)
			{
				give_item(id, "weapon_hegrenade");
				cs_set_user_money(id, cs_get_user_money(id) - hegren_price);
			}
			else
			{
				client_print_color(id, print_team_default, "%L", id, "GL_HEGREN_NOTMONEY");
			}
			return PLUGIN_HANDLED;
		}
		else if(iItem == CSW_HEGRENADE && user_has_weapon(id, CSW_HEGRENADE))
		{
			if(cs_get_user_bpammo(id, CSW_HEGRENADE) < hegren_pcs)
			{
				if(cs_get_user_money(id) >= hegren_add_price)
				{
					hegren_add_price += add_price;
					cs_set_user_bpammo(id, CSW_HEGRENADE, cs_get_user_bpammo(id, CSW_HEGRENADE) + 1);
					cs_set_user_money(id, cs_get_user_money(id) - hegren_add_price);
				}
				else
				{
					client_print_color(id, print_team_default, "%L", id, "GL_HEGREN_NOTMONEY");
				}
			}
			else
			{
				client_print_color(id, print_team_default, "%L", id, "GL_HEGREN_LIMIT");
			}
			return PLUGIN_HANDLED;
		}
		if(iItem == CSW_SMOKEGRENADE && !user_has_weapon(id, CSW_SMOKEGRENADE))
		{
			if(cs_get_user_money(id) >= sgren_price)
			{
				give_item(id, "weapon_smokegrenade");
				cs_set_user_money(id, cs_get_user_money(id) - sgren_price);
			}
			else
			{
				client_print_color(id, print_team_default, "%L", id, "GL_SMOKE_NOTMONEY");
			}
			return PLUGIN_HANDLED;
		}
		else if(iItem == CSW_SMOKEGRENADE && user_has_weapon(id, CSW_SMOKEGRENADE))
		{
			if(cs_get_user_bpammo(id, CSW_SMOKEGRENADE) < sgren_pcs)
			{
				if(cs_get_user_money(id) >= sgren_add_price)
				{
					sgren_add_price += add_price;
					cs_set_user_bpammo(id, CSW_SMOKEGRENADE, cs_get_user_bpammo(id, CSW_SMOKEGRENADE) + 1);
					cs_set_user_money(id, cs_get_user_money(id) - sgren_add_price);
				}
				else
				{
					client_print_color(id, print_team_default, "%L", id, "GL_SMOKE_NOTMONEY");
				}
			}
			else
			{
				client_print_color(id, print_team_default, "%L", id, "GL_SMOKE_LIMIT");
			}
			return PLUGIN_HANDLED;
		}
	}
	else
	{
		client_print_color(id, print_team_default, "%L", id, "GL_PURCHASETIME");
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

public GetAliasId(szAlias[])
{
	static Trie:tAliasesIds = Invalid_Trie;
	if(tAliasesIds == Invalid_Trie)
	{
		tAliasesIds = TrieCreate();
		TrieSetCell(tAliasesIds, "flash", CSW_FLASHBANG);
		TrieSetCell(tAliasesIds, "hegren", CSW_HEGRENADE);
		TrieSetCell(tAliasesIds, "sgren", CSW_SMOKEGRENADE);
	}
	strtolower(szAlias);
	new iId;
	if(TrieGetCell(tAliasesIds, szAlias, iId))
	{
		return iId;
	}
	return 0;
}